/************************************************************************/
/*  t@C  :app.c													*/
/*  H/W			:Pi:Co(SH7125)											*/
/*  쐬      :2012/06/19												*/
/*	쐬		:T.Kusumi												*/
/*	vWFNg:}CN}EXŊyg							*/
/*	W[	:AvP[V									*/
/************************************************************************/
#include	"common.h"
#include	"app.h"

/************************************************/
/*	AvP[V C		(app_main)		*/
/************************************************/
/*	XCb`ɂă[h؂ւAΉ	*/
/*	sB							*/
/************************************************/
void app_main(void)
{
	int	mode;					//[h
	//
	mode = 1;					//[h
	app_dispMode(mode);			//[h\
	//
	while(1)
	{
		mode = app_getMode(mode);	//[hݒ
		switch(mode)
		{
			case 1:				//[hPixAbvj
				app_mode1();
				break;
			case 2:				//[hQiZT[̒lPCɑMBj
				app_mode2();
				break;
			case 3:				//[hR
				app_mode3();
				break;
			case 4:				//[hS
				app_mode4();
				break;
			case 5:				//[hT
				app_mode5();
				break;
			case 6:				//[hU
				app_mode6();
				break;
			case 7:				//[hV
				app_mode7();
				break;
			case 8:				//[hW
				app_mode8();
				break;
			case 9:				//[hX
				app_mode9();
				break;
			case 10:			//[hPO
				app_mode10();
				break;
			case 11:			//[hPP
				app_mode11();
				break;
			case 12:			//[hPQ
				app_mode12();
				break;
			case 13:			//[hPR
				app_mode13();
				break;
			case 14:			//[hPS
				app_mode14();
				break;
			case 15:			//[hPT
				app_mode15();
				break;
		}
	}
}

/************************************************/
/*	[h\					(app_dispMode)	*/
/************************************************/
/*	݂̃[hLED2iŕ\A[h	*/
/*	ĈႤK̃uU[炷B			*/
/*----------------------------------------------*/
/*	IN :int	i_mode c [h					*/
/************************************************/
void app_dispMode(int i_mode)
{
	int	freq[15] = {BZ_FREQ_DO
				   ,BZ_FREQ_RE
				   ,BZ_FREQ_MI
				   ,BZ_FREQ_FA
				   ,BZ_FREQ_SO
				   ,BZ_FREQ_LA
				   ,BZ_FREQ_SI
				   ,BZ_FREQ_DO2
				   ,BZ_FREQ_RE2
				   ,BZ_FREQ_MI2
				   ,BZ_FREQ_FA2
				   ,BZ_FREQ_SO2
				   ,BZ_FREQ_LA2
				   ,BZ_FREQ_SI2
				   ,BZ_FREQ_DO3
				  };
	//[h\
	ctrl_led_num(i_mode);					//LEDɃ[h\
	ctrl_bz(freq[i_mode-1], 100);			//uU[
}

/************************************************/
/*	[hݒ					(app_getMode)	*/
/************************************************/
/*	[hݒ菈								*/
/************************************************/
int app_getMode(int i_currentMode)
{
	//
	int mode;
	unsigned char sw_b;			//XCb`̏
	unsigned char sw_y;			//XCb`̏
	unsigned char sw_r;			//ԃXCb`̏
	//
	mode = i_currentMode;		//[h
	//
	while(1)
	{
		//ׂẴXCb`̒l擾B
		ctrl_sw_all(&sw_b, &sw_y, &sw_r);
		//XCb`̒l`FbN
		if(sw_b == SW_ON)
		{
			//XCb`
			mode++;					//[hJEgAbv
			if(mode > 15)
			{
				mode = 1;
			}
			app_dispMode(mode);	//[h\
		}
		else if(sw_r == SW_ON)
		{
			//ԃXCb`
			mode--;					//[hJEg_E
			if(mode < 1)
			{
				mode = 15;
			}
			app_dispMode(mode);	//[h\
		}
		else if(sw_y == SW_ON)
		{
			//XCb`
			break;
		}
	}
	//
	return mode;
}

/************************************************/
/*	AvP[V S[		(app_goal)		*/
/************************************************/
/*	4LEDׂē_AB			*/
/*	E珇ɓ_Aׂē_A		*/
/*	E珇ɏB						*/
/************************************************/
void app_goal(void)
{
	//[vJE^[
	int cnt;
	//S_
	ctrl_led_on();
	//Ԃ
	for(cnt = 0; cnt <= 10000000; cnt++);
	//S
	ctrl_led_off();
	//
	while(1)
	{
		//Ԃ
		for(cnt = 0; cnt <= 10000000; cnt++);
		//ELED_
		ctrl_led_r(LED_ON);
		//Ԃ
		for(cnt = 0; cnt <= 10000000; cnt++);
		//EOLED_
		ctrl_led_fr(LED_ON);
		//Ԃ
		for(cnt = 0; cnt <= 10000000; cnt++);
		//OLED_
		ctrl_led_fl(LED_ON);
		//Ԃ
		for(cnt = 0; cnt <= 10000000; cnt++);
		//LED_
		ctrl_led_l(LED_ON);
		//Ԃ
		for(cnt = 0; cnt <= 10000000; cnt++);
		//ELED
		ctrl_led_r(LED_OFF);
		//Ԃ
		for(cnt = 0; cnt <= 10000000; cnt++);
		//EOLED
		ctrl_led_fr(LED_OFF);
		//Ԃ
		for(cnt = 0; cnt <= 10000000; cnt++);
		//OLED
		ctrl_led_fl(LED_OFF);
		//Ԃ
		for(cnt = 0; cnt <= 10000000; cnt++);
		//LED
		ctrl_led_l(LED_OFF);
		//Ԃ
		for(cnt = 0; cnt <= 10000000; cnt++);
	}
}

/************************************************/
/*	[hP̏				(app_mode1)		*/
/************************************************/
/*	xAbv炷B					*/
/************************************************/
void app_mode1(void)
{
	//xAbv
	int tempo = 200;
	//
	ctrl_bz_melody(BZ_FREQ_SO, 	1, tempo);
	ctrl_bz_melody(BZ_FREQ_SO, 	1, tempo);
	ctrl_bz_melody(BZ_FREQ_SO, 	1, tempo);
	ctrl_bz_melody(BZ_FREQ_FA, 	1, tempo);
	ctrl_bz_melody(BZ_FREQ_REST,1, tempo);
	ctrl_bz_melody(BZ_FREQ_LA, 	1, tempo);
	ctrl_bz_melody(BZ_FREQ_SO, 	4, tempo);
}

/************************************************/
/*	[hQ̏				(app_mode2)		*/
/************************************************/
/*	ZT[̒lPCɑMB				*/
/************************************************/
void app_mode2(void)
{
	//ZT[̒lPCɑMB
	int r;									//EZT[̒l
	int fr;									//OEZT[̒l
	int fl;									//OZT[̒l
	int l;									//ZT[̒l
	unsigned char sw_r;						//EXCb`̏
	unsigned char sw_c;						//XCb`̏
	unsigned char sw_l;						//XCb`̏
	//
	while(1)
	{
		//ZT[l擾
		r  = ctrl_adc_r();					//E
		fr = ctrl_adc_fr();					//OE
		fl = ctrl_adc_fl();					//O
		l  = ctrl_adc_l();					//
		// M
		ctrl_com_send("\rR:",r);
		ctrl_com_send(", FR:",fr);
		ctrl_com_send(", FL:",fl);
		ctrl_com_send(", L:",l);
		//ׂẴXCb`̒l擾B
		ctrl_sw_all(&sw_r, &sw_c, &sw_l);
		//XCb`̒l`FbN
		if(sw_r == SW_ON || sw_c == SW_ON || sw_l == SW_ON)
		{
			//ǂꂩ̃XCb`ꂽuU[炵AIB
			ctrl_bz(BZ_FREQ_DO, 100);		//uU[ihj
			break;
		}
	}
}

/************************************************/
/*	[hȐ				(app_mode3)		*/
/************************************************/
/*												*/
/************************************************/
void app_mode3(void)
{
}

/************************************************/
/*	[hS̏				(app_mode4)		*/
/************************************************/
/*												*/
/************************************************/
void app_mode4(void)
{
}

/************************************************/
/*	[hT̏				(app_mode5)		*/
/************************************************/
/*												*/
/************************************************/
void app_mode5(void)
{
}

/************************************************/
/*	[hȔ				(app_mode6)		*/
/************************************************/
/*												*/
/************************************************/
void app_mode6(void)
{
}

/************************************************/
/*	[hV̏				(app_mode7)		*/
/************************************************/
/*												*/
/************************************************/
void app_mode7(void)
{
}

/************************************************/
/*	[hW̏				(app_mode8)		*/
/************************************************/
/*												*/
/************************************************/
void app_mode8(void)
{
}

/************************************************/
/*	[hX̏				(app_mode9)		*/
/************************************************/
/*												*/
/************************************************/
void app_mode9(void)
{
}

/************************************************/
/*	[hPȌ			(app_mode10)	*/
/************************************************/
/*												*/
/************************************************/
void app_mode10(void)
{
}

/************************************************/
/*	[hPP̏			(app_mode11)	*/
/************************************************/
/*												*/
/************************************************/
void app_mode11(void)
{
}

/************************************************/
/*	[hPQ̏			(app_mode12)	*/
/************************************************/
/*												*/
/************************************************/
void app_mode12(void)
{
}

/************************************************/
/*	[hPȐ			(app_mode13)	*/
/************************************************/
/*												*/
/************************************************/
void app_mode13(void)
{
}

/************************************************/
/*	[hPS̏			(app_mode14)	*/
/************************************************/
/*												*/
/************************************************/
void app_mode14(void)
{
}

/************************************************/
/*	[hPT̏			(app_mode15)	*/
/************************************************/
/*												*/
/************************************************/
void app_mode15(void)
{
}
