/************************************************************************/
/*  t@C  :init.c													*/
/*  H/W			:Pi:Co(SH7125)											*/
/*  쐬      :2012/04/15												*/
/*	쐬		:T.Kusumi												*/
/*	vWFNg:}CN}EXŊyg							*/
/*	W[	:												*/
/************************************************************************/
#include	"iodefine.h"
#include	"common.h"
#include	"init.h"

/************************************************/
/*	NbN				(init_clock)	*/
/************************************************/
/*	CPUNbNݒ肷B(48MHz)				*/
/************************************************/
void init_clock(void)
{
	//NbN
	int i;
	//
	CPG.FRQCR.BIT.IFC = 1;				//CPUNbNX'tal̎g~Sɐݒ肷(ĺ~Q)
	for(i = 0; i < 0xfffff; i++)	;	//PLL̓삪肷܂ő҂
}

/************************************************/
/*	I/O|[g					(init_io)	*/
/************************************************/
/*	|[gB						*/
/************************************************/
void init_io(void)
{
	//XCb`
	PFC.PBIORL.BIT.B1		= 0;	//PB1͂ɐݒiEj
	PFC.PBIORL.BIT.B2		= 0;	//PB2͂ɐݒij
	PFC.PBIORL.BIT.B3		= 0;	//PB3͂ɐݒij
	//LED
	PFC.PEIORL.BIT.B0		= 1;	//PE0o͂ɐݒij
	PFC.PEIORL.BIT.B1		= 1;	//PE1o͂ɐݒiOj
	PFC.PEIORL.BIT.B2		= 1;	//PE2o͂ɐݒiOEj
	PFC.PEIORL.BIT.B3		= 1;	//PE3o͂ɐݒiEj
	//uU[
	PFC.PEIORL.BIT.B6		= 1;	//PE6o͂ɐݒ
	//uU[MTU
	PFC.PECRL2.BIT.PE6MD 	= 1;	//PE6MTU[qɐݒ
	//ZT[LED
	PFC.PAIORL.BIT.B6		= 1;	//PA6o͂ɐݒij
	PFC.PAIORL.BIT.B7		= 1;	//PA7o͂ɐݒiEj
	PFC.PAIORL.BIT.B8		= 1;	//PA8o͂ɐݒiOj
	PFC.PAIORL.BIT.B9		= 1;	//PA9o͂ɐݒiOEj
}

/************************************************/
/*	CMT						(init_cmt)	*/
/************************************************/
/*	CMTݒ肷B							*/
/************************************************/
void init_cmt(void)
{
	//CMTX^oC[h
	STB.CR4.BIT._CMT = 0;
	//
	CMT.CMSTR.BIT.STR0 = 0;			//CMT0JEg~
	//CMT0͐p^C}[
	CMT0.CMCSR.BIT.CMIE = 1;		//荞݂
	CMT0.CMCSR.BIT.CKS = 0;			//JEgNbNP/8 = 3MHz
	CMT0.CMCSR.BIT.CMF = 0;			//tONA
	CMT0.CMCOR = 3000-1;			//1msƂɊ荞
	//
	INTC.IPRJ.BIT._CMT0 = 0x0f;		//荞ݗDxōɐݒ
	//
	CMT.CMSTR.BIT.STR0 = 1;			//CMT0JEgJn
}

/************************************************/
/*	MTU						(init_mtu)	*/
/************************************************/
/*	MTUݒ肷B							*/
/*	MTU22:uU[p								*/
/************************************************/
void init_mtu(void)
{
	//MTU2X^oC[h
	STB.CR4.BIT._MTU2 = 0;
	//
	MTU2.TSTR.BYTE=0;				//^C}Xgbv
	//uU[pMTU
	MTU22.TCR.BIT.TPSC = 0;			//MTU22̓NbN24MHz
	MTU22.TCR.BIT.CCLR = 2;			//TGRBRyA}b`ŃJE^NA
	MTU22.TIOR.BIT.IOB = 1;			//o0RyA}b`0o
	MTU22.TIOR.BIT.IOA = 2;			//o0RyA}b`1o
	MTU22.TGRA = 4000;
	MTU22.TGRB = 12000;				//Ug2kHz
	MTU22.TMDR.BIT.MD = 2;			//PWM[h1ɐݒ
	//
	MTU2.TOER.BYTE=0xff;			//MTUo͒[qo͋
	//
	MTU2.TSTR.BIT.CST2 = 0;			//^C}Xgbv
}

/************************************************/
/*	A/Dϊ					(init_adc)	*/
/************************************************/
/*	A/Dϊݒ肷B						*/
/************************************************/
void init_adc(void)
{
	STB.CR4.BIT._AD0     = 0;		//AD0̃X^oC
	STB.CR4.BIT._AD1     = 0;		//AD1̃X^oC
	//
	AD0.ADCR.BIT.ADST    = 0;  		//AD~
	AD0.ADCSR.BIT.ADF    = 0;  		//ADFtONA
	AD0.ADCSR.BIT.ADIE   = 0;   	//݋֎~
	AD0.ADCSR.BIT.TRGE   = 0;   	//gKCl[u
	AD0.ADCSR.BIT.CONADF = 0;   	//ADFRg[(ƗADF)
	AD0.ADCSR.BIT.STC    = 0;   	//Xe[gRg[(50Xe[g)
	AD0.ADCSR.BIT.CKSL   = 3;   	//ӓNbNP
	AD0.ADCSR.BIT.ADM    = 0;   	//VOXL
	AD0.ADCSR.BIT.ADCS   = 0;   	//TCNXLȂ
	AD0.ADCSR.BIT.CH     = 0;   	//AD0-ch0I
	//
	AD1.ADCR.BIT.ADST    = 0;  		//AD~
	AD1.ADCSR.BIT.ADF    = 0;  		//ADFtONA
	AD1.ADCSR.BIT.ADIE   = 0;   	//݋֎~
	AD1.ADCSR.BIT.TRGE   = 0;   	//gKCl[u
	AD1.ADCSR.BIT.CONADF = 0;   	//ADFRg[(ƗADF)
	AD1.ADCSR.BIT.STC    = 0;   	//Xe[gRg[(50Xe[g)
	AD1.ADCSR.BIT.CKSL   = 3;   	//ӓNbNP
	AD1.ADCSR.BIT.ADM    = 0;   	//VOXL
	AD1.ADCSR.BIT.ADCS   = 0;   	//TCNXLȂ 
	AD1.ADCSR.BIT.CH     = 0;   	//AD1-ch0I
}


/************************************************/
/*	ʐM						(init_sci)	*/
/************************************************/
/*	ʐMݒ肷B						*/
/************************************************/
void init_sci(void){
	//
	STB.CR3.BIT._SCI1 = 0;       	//SCĨX^oC
	//
	SCI1.SCSCR.BIT.RIE  = 0;      	//M
	SCI1.SCSCR.BIT.TIE  = 0;		//M
	SCI1.SCSCR.BIT.TEIE = 0;		//MI
	SCI1.SCSCR.BIT.MPIE = 0;		//MP݃Cl[u
	SCI1.SCSCR.BIT.TE   = 0;     	//M
	SCI1.SCSCR.BIT.RE   = 0;		//M
	//
	SCI1.SCSCR.BIT.CKE  = 0;
	//
	SCI1.SCSMR.BIT.CA   = 0;		//[h
	SCI1.SCSMR.BIT.CHR  = 0;		//8rbg
	SCI1.SCSMR.BIT._PE  = 0;		//peB֎~
	SCI1.SCSMR.BIT.OE   = 0;		//
	SCI1.SCSMR.BIT.STOP = 0;		//1Xgbvrbg
	SCI1.SCSMR.BIT.MP   = 0;		//}`vZbT[h֎~
	SCI1.SCSMR.BIT.CKS  = 0;		//NbNZNg 
	//
	SCI1.SCBRR = 19;				//{[[g=38400 bps
	//
	PFC.PACRL2.BIT.PA4MD = 1;		//TXD|[gݒ
	PFC.PACRL1.BIT.PA3MD = 1;		//RXD|[gݒ
	//
	SCI1.SCSCR.BIT.TE    = 1;		//M
	SCI1.SCSCR.BIT.RE    = 1;		//M
}

/************************************************/
/*	H/W						(init_all)	*/
/************************************************/
/*	ׂĂH/W̏sB					*/
/************************************************/
void init_all(void)
{
	init_clock();		//CPU̓gݒ
	init_io();			//I/O|[gݒ
	init_cmt();			//CMTݒ
	init_mtu();			//MTȔ
	init_adc();			//ADC̏
	init_sci();			//SCȈ
}
